Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package classpath
  Definition Classes
    nsc
- AggregateClassPath
- ClassFileEntry
- ClassPathEntries
- ClassPathFactory
- CtSymClassPath
- DirectoryClassPath
- DirectoryLookup
- DirectorySourcePath
- FileBasedCache
- FileUtils
- JFileDirectoryLookup
- JrtClassPath
- PackageEntry
- PackageNameUtils
- SourceFileEntry
- VirtualDirectoryClassPath
- ZipAndJarClassPathFactory
- ZipAndJarFileLookupFactory
- ZipAndJarSourcePathFactory
- ZipArchiveFileLookup

t

scala.tools.nsc.classpath

# ZipArchiveFileLookup

###

#### trait ZipArchiveFileLookup[FileEntryType <: ClassRepresentation] extends ClassPath with Closeable

A trait allowing to look for classpath entries of given type in zip and jar files. It provides common logic for classes handling class and source files. It's aware of things like e.g. META-INF directory which is correctly skipped.

Source
  ZipArchiveFileLookup.scala

Linear Supertypes
Closeable, AutoCloseable, ClassPath, AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ZipArchiveFileLookup
2. Closeable
3. AutoCloseable
4. ClassPath
5. AnyRef
6. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Abstract Value Members

1.  abstract def asSourcePathString: String

   The whole sourcepath in the form of one String.

   The whole sourcepath in the form of one String.

   Definition Classes
     ClassPath
2.  abstract def createFileEntry(file: reflect.io.FileZipArchive.Entry): FileEntryType
   Attributes
     protected
3.  abstract def findClassFile(className: String): Option[AbstractFile]

   Returns the classfile for an external name, e.g., "java.lang.String".

   Returns the classfile for an external name, e.g., "java.lang.String". This method does not return source files.

   This method is used by the classfile parser. When parsing a Java class, its own inner classes are entered with a `ClassfileLoader` that parses the classfile returned by this method. It is also used in the backend, by the inliner, to obtain the bytecode when inlining from the classpath. It's also used by scalap.

   Definition Classes
     ClassPath
4.  abstract def isRequiredFileType(file: AbstractFile): Boolean
   Attributes
     protected
5.  abstract def release: Option[String]
6.  abstract val zipFile: File

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from ZipArchiveFileLookup[FileEntryType] toany2stringadd[ZipArchiveFileLookup[FileEntryType]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (ZipArchiveFileLookup[FileEntryType], B)
   Implicit
     This member is added by an implicit conversion from ZipArchiveFileLookup[FileEntryType] toArrowAssoc[ZipArchiveFileLookup[FileEntryType]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def asClassPathString: String

   The whole classpath in the form of one String.

   The whole classpath in the form of one String.

   Definition Classes
     ClassPath
7.  def asClassPathStrings: Seq[String]
   Definition Classes
     ZipArchiveFileLookup → ClassPath
8.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
9.  def asURLs: Seq[URL]
   Definition Classes
     ZipArchiveFileLookup → ClassPath
10.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
11.  def close(): Unit
    Definition Classes
      ZipArchiveFileLookup → Closeable → AutoCloseable
12.  def ensuring(cond: (ZipArchiveFileLookup[FileEntryType]) => Boolean, msg: => Any): ZipArchiveFileLookup[FileEntryType]
    Implicit
      This member is added by an implicit conversion from ZipArchiveFileLookup[FileEntryType] toEnsuring[ZipArchiveFileLookup[FileEntryType]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: (ZipArchiveFileLookup[FileEntryType]) => Boolean): ZipArchiveFileLookup[FileEntryType]
    Implicit
      This member is added by an implicit conversion from ZipArchiveFileLookup[FileEntryType] toEnsuring[ZipArchiveFileLookup[FileEntryType]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: Boolean, msg: => Any): ZipArchiveFileLookup[FileEntryType]
    Implicit
      This member is added by an implicit conversion from ZipArchiveFileLookup[FileEntryType] toEnsuring[ZipArchiveFileLookup[FileEntryType]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: Boolean): ZipArchiveFileLookup[FileEntryType]
    Implicit
      This member is added by an implicit conversion from ZipArchiveFileLookup[FileEntryType] toEnsuring[ZipArchiveFileLookup[FileEntryType]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
17.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
18.  def file(inPackage: String, name: String): Option[FileEntryType]
    Attributes
      protected
19.  def files(inPackage: String): Seq[FileEntryType]
    Attributes
      protected
20.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
21.  def findClass(className: String): Option[ClassRepresentation]

    Returns the class file and / or source file for a given external name, e.g., "java.lang.String".

    Returns the class file and / or source file for a given external name, e.g., "java.lang.String". If there is both a class file and source file, the compiler can decide whether to read the class file or compile the source file.

    Internally this seems to be used only by `ScriptRunner`, but only to call `.isDefined`. That could probably be implemented differently.

    Externally, it is used by sbt's compiler interface: https://github.com/sbt/sbt/blob/v0.13.15/compile/interface/src/main/scala/xsbt/CompilerInterface.scala#L249 Jason has some improvements for that in the works (https://github.com/scala/bug/issues/10289#issuecomment-310022699)

    Definition Classes
      ClassPath
22.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from ZipArchiveFileLookup[FileEntryType] toStringFormat[ZipArchiveFileLookup[FileEntryType]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
23.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
24.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
25.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
26.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
27.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
28.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
29.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
30.  def toString(): String
    Definition Classes
      AnyRef → Any
31.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
32.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
33.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def asClasspathString: String
   Definition Classes
     ClassPath
   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.5) use asClassPathString instead of this one

2.  def →[B](y: B): (ZipArchiveFileLookup[FileEntryType], B)
   Implicit
     This member is added by an implicit conversion from ZipArchiveFileLookup[FileEntryType] toArrowAssoc[ZipArchiveFileLookup[FileEntryType]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from Closeable

### Inherited from AutoCloseable

### Inherited from ClassPath

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromZipArchiveFileLookup[FileEntryType] to any2stringadd[ZipArchiveFileLookup[FileEntryType]]

### Inherited by implicit conversion StringFormat fromZipArchiveFileLookup[FileEntryType] to StringFormat[ZipArchiveFileLookup[FileEntryType]]

### Inherited by implicit conversion Ensuring fromZipArchiveFileLookup[FileEntryType] to Ensuring[ZipArchiveFileLookup[FileEntryType]]

### Inherited by implicit conversion ArrowAssoc fromZipArchiveFileLookup[FileEntryType] to ArrowAssoc[ZipArchiveFileLookup[FileEntryType]]

### Ungrouped